unit LngShrtU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    FileList: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    lblLong: TLabel;
    lblShort: TLabel;
    lblShortAgain: TLabel;
    procedure FileListChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure ExtractOtherNameC(SrcName, DestName: PChar; ShortToLong: ByteBool); assembler;
asm
  lds si, SrcName
  les di, DestName
  mov ax, $7160
  mov cl, ShortToLong
  inc cl { 1 - get short name, 2 - get long name }
  mov ch, 0 { return full path, not subst }
  int $21
end;

function ExtractShortPathName(const FileName: string): string;
var
  LongNameBuf, ShortNameBuf: array[0..255] of Char;
begin
  ExtractOtherNameC(StrPCopy(LongNameBuf, FileName), ShortNameBuf, False);
  Result := StrPas(ShortNameBuf)
end;

function ExtractLongPathName(const FileName: string): string;
var
  LongNameBuf, ShortNameBuf: array[0..255] of Char;
begin
  ExtractOtherNameC(StrPCopy(ShortNameBuf, FileName), LongNameBuf, True);
  Result := StrPas(LongNameBuf)
end;

procedure TForm1.FileListChange(Sender: TObject);
begin
  if FileList.ItemIndex = -1 then Exit;
  lblShort.Caption := FileList.FileName;
  lblLong.Caption := ExtractLongPathName(lblShort.Caption);
  lblShortAgain.Caption := ExtractShortPathName(lblLong.Caption)
end;

end.
