unit LongToShort2U;

{$ifdef Ver80} { Delphi 1.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver90} { Delphi 2.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver93} { C++ Builder 1.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver100} { Delphi 3.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver110} { C++ Builder 3.0x }
  {$define DelphiLessThan4}
{$endif}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    FileList: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    lblLong: TLabel;
    lblShort: TLabel;
    lblLongAgain: TLabel;
    procedure FileListChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI;

{$R *.DFM}

{$ifdef DelphiLessThan4}
function ExtractShortPathName(const FileName: string): string;
{$ifdef Win32}
var
  Buffer: array[0..MAX_PATH] of Char;
begin
  SetString(Result, Buffer,
    GetShortPathName(PChar(FileName), Buffer, SizeOf(Buffer)));
end;
{$else} { Win16}
begin
  Result := FileName
end;
{$endif}
{$endif}

function ExtractLongFileName(const FileName: string): string;
var
  Info: TSHFileInfo;
begin
  if SHGetFileInfo(PChar(FileName), 0, Info, Sizeof(Info), SHGFI_DISPLAYNAME) <> 0 then
    Result := String(Info.szDisplayName)
  else
    Result := FileName;
end;

function ExtractLongPathName(const PathName: String): String;
var
  LastSlash, PathPtr: PChar;
begin
  Result := '';
  PathPtr := PChar(PathName);
  LastSlash := StrRScan(PathPtr, '\');
  while LastSlash <> nil do
  begin
    Result := '\' + ExtractLongFileName(PathPtr) + Result;
    if LastSlash <> nil then
    begin
      LastSlash^ := #0;
      LastSlash := StrRScan(PathPtr, '\');
    end
  end;
  Result := PathPtr + Result;
end;

procedure TForm1.FileListChange(Sender: TObject);
begin
  if FileList.ItemIndex = -1 then Exit;
  lblLong.Caption := FileList.FileName;
  lblShort.Caption := ExtractShortPathName(lblLong.Caption);
  lblLongAgain.Caption := ExtractLongPathName(lblShort.Caption)
end;

end.
