unit LongToShortU;

{$ifdef Ver80} { Delphi 1.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver90} { Delphi 2.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver93} { C++ Builder 1.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver100} { Delphi 3.0x }
  {$define DelphiLessThan4}
{$endif}
{$ifdef Ver110} { C++ Builder 3.0x }
  {$define DelphiLessThan4}
{$endif}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    FileList: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    lblLong: TLabel;
    lblShort: TLabel;
    lblLongAgain: TLabel;
    procedure FileListChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$ifdef DelphiLessThan4}
function ExtractShortPathName(const FileName: string): string;
var
  Buffer: array[0..MAX_PATH] of Char;
begin
  SetString(Result, Buffer,
    GetShortPathName(PChar(FileName), Buffer, SizeOf(Buffer)));
end;
{$endif}

function ExtractLongFileName(const FileName: string): string;
var
  SearchRec: TSearchRec;
begin
  //Just in case something goes wrong
  Result := FileName;
  //Look for directories as well as just normal files
  if FindFirst(FileName, faDirectory, SearchRec) = 0 then
  begin
    //If we find it, return the long name
    Result := SearchRec.Name;
    //If we don't have a long name, return the short name
    if Result = '' then
      Result := String(SearchRec.FindData.cAlternateFileName);
  end;
  //Tidy up
  FindClose(SearchRec);
end;

function ExtractLongPathName(const PathName: String): String;
var
  PathPart: String;
  Index: Word;
begin
  PathPart := PathName;
  { Get long name of the deepest level of path (file name or dir)  }
  Result := ExtractLongFileName(PathPart);
  { Get long version of all directories in path }
  Index := Length(PathPart);
  repeat
    while (PathPart[Index] <> '\') and (Index > 4) do
      Dec(Index);
    if PathPart[Index] = '\' then
    begin
      PathPart[Index] := #0;
      Result := ExtractLongFileName(PathPart) + '\' + Result
    end
  until Index = 4;
  { Finally add the drive letter }
  Result := Copy(PathName, 1, 3) + Result;
end;

procedure TForm1.FileListChange(Sender: TObject);
begin
  if FileList.ItemIndex = -1 then Exit;
  lblLong.Caption := FileList.FileName;
  lblShort.Caption := ExtractShortPathName(lblLong.Caption);
  lblLongAgain.Caption := ExtractLongPathName(lblShort.Caption)
end;

end.
