unit TblEdit1;

interface

procedure Register;

implementation

uses
  DBTables, DsgnIntf, Dialogs, SysUtils;

type
  TTableEditor = class(TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
    procedure Edit; override;
  end;

function TTableEditor.GetVerbCount: Integer;
begin
  Result := 3;
  ShowMessage(Format(
    'Someone wants to know how many component editors ' +
    'we are adding. Well, the answer is %d', [Result]))
end;

function TTableEditor.GetVerb(Index: Integer): string;
begin
  { Someone wants the menu caption for one of our component editors }
  Result := Format('Component editor no. %d', [Index + 1])
end;

procedure TTableEditor.ExecuteVerb(Index: Integer);
begin
  ShowMessage('Someone has chosen one of our component editors. Here goes...');
  ShowMessage(GetVerb(Index))
end;

procedure TTableEditor.Edit;
begin
  ShowMessage(Format(
    'Someone double-clicked on a %s component called "%s"',
    [Component.ClassName, Component.Name]));
  { This would do the default behaviour, maybe }
  { manufacturing or locating an event handler: }
  { inherited Edit }

  { However this, will execute a component editor: }
  ExecuteVerb(0)
end;

procedure Register;
begin
  RegisterComponentEditor(TTable, TTableEditor)
end;

end.
