DROP TABLE Employees
go

CREATE TABLE Employees(
  EmpEmployeeID Integer,
  EmpName varchar(20),
  EmpHourlyOrSalary char(1),
  EmpPayPeriod smallint,
  EmpHourlyPayRate money,
  EmpAnnualPayRate money,
  EmpWeeklyPayRate money,
  EmpPeriodPayRate money,
  EmpScheduledWorkHours float,
  EmpDateOfNextPayReview datetime,
  EmpJobCode char(5),
  EmpPayScaleCode char(5),
  EmpStepNo smallint)
go

INSERT Employees VALUES (1, 'Barber, Floyd', 'H', 26, 9.50, 19760.00, 380, 760, 80, '25 Sep 1999', 'JP', 'FM', 3)
INSERT Employees VALUES (1, 'Woozie, Suzy', 'S', 24, 7.00, 14560.00, 280, 560, 86.667, '27 Sep 1999', 'JR', 'FM', 1)
go

DROP TABLE JobCodes
go

CREATE TABLE JobCodes(
  JbcJobCode char(5),
  JbcDescription varchar(25),
  JbcMaxHourlyRate money NULL,
  JbcMaxAnnualRate money NULL)
go

INSERT JobCodes VALUES ('JP', 'Parts Manager', 12.00, 24960.00)
INSERT JobCodes VALUES ('JR', 'Repair Manager', NULL, NULL)
go

DROP TABLE PayScales
go

CREATE TABLE PayScales(
  PscPayScaleCode char(5),
  PscDescription varchar(25),
  PscIntervalType char(1))
go

INSERT PayScales VALUES ('AM', 'Apprentice', 'M')
INSERT PayScales VALUES ('FM', 'Floor Manager', 'D')
go

DROP TABLE PaySteps
go

CREATE TABLE PaySteps (
  StpPayScaleCode char(5),
  StpStepNo smallint,
  StpEffDate datetime,
  StpRate money,
  StpInterval smallint)
go

INSERT PaySteps VALUES ('FM', 1, '1/1/99', 7.00, 90)
INSERT PaySteps VALUES ('FM', 2, '1/1/99', 9.00, 120)
INSERT PaySteps VALUES ('FM', 3, '1/1/99', 9.50, 120)
INSERT PaySteps VALUES ('FM', 4, '1/1/99', 10.50, 120)
INSERT PaySteps VALUES ('FM', 5, '1/1/99', 11.50, 0)
INSERT PaySteps VALUES ('FM', 1, '9/10/99', 7.25, 90)
INSERT PaySteps VALUES ('FM', 2, '9/10/99', 9.25, 120)
INSERT PaySteps VALUES ('FM', 3, '9/10/99', 9.75, 120)
INSERT PaySteps VALUES ('FM', 4, '9/10/99', 10.75, 120)
INSERT PaySteps VALUES ('FM', 5, '9/10/99', 11.75, 0)
INSERT PaySteps VALUES ('FM', 4, '12/31/99', 10.85, 120)
INSERT PaySteps VALUES ('FM', 5, '12/31/99', 11.75, 180)
INSERT PaySteps VALUES ('FM', 6, '12/31/99', 13.00, 0)
go

  